
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Checklist_runsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const checklist_runs = await db.checklist_runs.create(
            {
                id: data.id || undefined,
        
        run_at: data.run_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        general_notes: data.general_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await checklist_runs.setBranch( data.branch || null, {
            transaction,
        });
        
        await checklist_runs.setChecklist( data.checklist || null, {
            transaction,
        });
        
        await checklist_runs.setCompleted_by( data.completed_by || null, {
            transaction,
        });
        
        await checklist_runs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return checklist_runs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const checklist_runsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                run_at: item.run_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                general_notes: item.general_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const checklist_runs = await db.checklist_runs.bulkCreate(checklist_runsData, { transaction });

        // For each item created, replace relation files
        

        return checklist_runs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const checklist_runs = await db.checklist_runs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.run_at !== undefined) updatePayload.run_at = data.run_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.general_notes !== undefined) updatePayload.general_notes = data.general_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await checklist_runs.update(updatePayload, {transaction});

        
        
        if (data.branch !== undefined) {
            await checklist_runs.setBranch(
              
              data.branch,
              
              { transaction }
            );
        }
        
        if (data.checklist !== undefined) {
            await checklist_runs.setChecklist(
              
              data.checklist,
              
              { transaction }
            );
        }
        
        if (data.completed_by !== undefined) {
            await checklist_runs.setCompleted_by(
              
              data.completed_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await checklist_runs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return checklist_runs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const checklist_runs = await db.checklist_runs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of checklist_runs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of checklist_runs) {
                await record.destroy({transaction});
            }
        });


        return checklist_runs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const checklist_runs = await db.checklist_runs.findByPk(id, options);

        await checklist_runs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await checklist_runs.destroy({
            transaction
        });

        return checklist_runs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const checklist_runs = await db.checklist_runs.findOne(
            { where },
            { transaction },
        );

        if (!checklist_runs) {
            return checklist_runs;
        }

        const output = checklist_runs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.checklist_run_items_checklist_run = await checklist_runs.getChecklist_run_items_checklist_run({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.branch = await checklist_runs.getBranch({
            transaction
        });
        
        
        output.checklist = await checklist_runs.getChecklist({
            transaction
        });
        
        
        output.completed_by = await checklist_runs.getCompleted_by({
            transaction
        });
        
        
        output.organizations = await checklist_runs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.branches,
        as: 'branch',
        
        where: filter.branch ? {
          [Op.or]: [
            { id: { [Op.in]: filter.branch.split('|').map(term => Utils.uuid(term)) } },
            {
              branch_name: {
                [Op.or]: filter.branch.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.store_checklists,
        as: 'checklist',
        
        where: filter.checklist ? {
          [Op.or]: [
            { id: { [Op.in]: filter.checklist.split('|').map(term => Utils.uuid(term)) } },
            {
              checklist_name: {
                [Op.or]: filter.checklist.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'completed_by',
        
        where: filter.completed_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.completed_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.completed_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.general_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'checklist_runs',
                        'general_notes',
                        filter.general_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.run_atRange) {
                const [start, end] = filter.run_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    run_at: {
                    ...where.run_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    run_at: {
                    ...where.run_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.checklist_runs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'checklist_runs',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.checklist_runs.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

